+width=`${MH_OBJ_DIR}/test/getcwidth "→n̈"`
+if test $? -ne 0; then
+ echo "getcwidth failed to run"
+ exit 1
+fi
+
+expected="$MH_TEST_DIR/$$.expected"
+actual="$MH_TEST_DIR/$$.actual"
+
+if test "$width" -eq 3; then
+cat > "$expected" <<EOF
+ 11 03/02 David st Hubbins Spın̈al Tap → Tap into America!<<Things are look
+EOF
+elif test "$width" -eq 2; then
+cat > "$expected" <<EOF
+ 11 03/02 David st Hubbins Spın̈al Tap → Tap into America!<<Things are looki
+EOF
+else
+ echo "Unsupported width for UTF-8 test string: $width"
+ exit 1
+fi
+
+run_prog scan -width 80 +inbox 11 > $actual || exit 1
+check "$expected" "$actual"
+
+#
+# Check decoding with an invalid multibyte sequence. We skip this test
+# if we don't have iconv support, since it requires converting from one
+# character set to another. Be sure we created the test file, though, because
+# it's required for the test right after it.
+#
+
+cat >`mhpath new` <<EOF
+From: Test12 <test12@example.com>
+To: Some User <user@example.com>
+Date: Mon, 31 Dec 2012 00:00:00
+Message-Id: 12@test.nmh
+Subject: =?UTF-8?B?MjAxMyBOZXcgWWVhcuKAmXMgRGVhbHMhIFN0YXJ0IHRoZSB5ZWFy?=
+ =?UTF-8?B?IHJpZ2h0IHdpdGggYmlnIHNhdmluZ3M=?=
+
+This message has an encoded Subject with an invalid character for the
+ISO-8859-1 character set, but it (U+2019) is valid UTF-8.
+EOF
+
+if test "$ICONV_ENABLED" -eq 1; then
+ cat >"$expected" <<EOF
+ 12 12/31 Test12 2013 New Year?s Deals! Start the year right
+EOF
+
+ # Don't use run_prog here because it loses those environment settings.
+ LC_CTYPE=ISO-8859-1 MM_CHARSET=ISO-8859-1 scan -width 75 last >"$actual"
+ check "$expected" "$actual"
+fi
+
+#
+# Find out the width of our Unicode apostrophe (U+2019). Some implementations
+# say it has a width of 2, but that seems totally bizarre to me.
+#
+
+width=`${MH_OBJ_DIR}/test/getcwidth U+2019`
+if test $? -ne 0; then
+ echo "getcwidth failed to run"
+ exit 1
+fi